/* A Bison parser, made by GNU Bison 3.0.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "ddcal.y" /* yacc.c:339  */

/* $Id: ddcal.y,v 1.28 2015/01/05 07:05:31 fabio Exp fabio $ */
#include <string.h>
#include <math.h>
#define DDCAL_MAIN
#include "ddcal.h"
  static void usage(char const *);

  struct symtab_t  symtab[NSYMS];


#line 78 "y.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    NAME = 258,
    NODE = 259,
    XNOR = 260,
    IMPLIES = 261,
    GETS = 262
  };
#endif
/* Tokens.  */
#define NAME 258
#define NODE 259
#define XNOR 260
#define IMPLIES 261
#define GETS 262

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 13 "ddcal.y" /* yacc.c:355  */

    DdNode * dval;
    struct symtab_t *symp;
    void *vptr;

#line 138 "y.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_Y_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 155 "y.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  19
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   107

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  23
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  8
/* YYNRULES -- Number of rules.  */
#define YYNRULES  30
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  55

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   262

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      16,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     9,     2,     2,     2,     2,     2,    15,
      20,    21,    12,    11,     2,     2,     2,    13,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    22,     2,
       2,    17,     2,     8,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    18,     2,    19,    10,    14,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,    32,    32,    34,    38,    39,    45,    46,    55,    60,
      69,    87,    87,    96,   100,   109,   118,   127,   136,   145,
     154,   168,   182,   214,   223,   226,   230,   252,   260,   270,
     308
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NAME", "NODE", "XNOR", "IMPLIES",
  "GETS", "'?'", "'!'", "'^'", "'+'", "'*'", "'/'", "'_'", "'\\''",
  "'\\n'", "'='", "'['", "']'", "'('", "')'", "':'", "$accept", "program",
  "statement_list", "statement", "$@1", "expression", "namelist",
  "command", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,    63,    33,
      94,    43,    42,    47,    95,    39,    10,    61,    91,    93,
      40,    41,    58
};
# endif

#define YYPACT_NINF -11

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-11)))

#define YYTABLE_NINF -4

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int8 yypact[] =
{
       9,    -5,    -2,   -11,   -11,   -11,     3,    23,    28,    32,
     -11,    64,    31,   -11,     3,    42,   -11,    50,    46,   -11,
      35,   -11,     3,     3,     3,     3,     3,     3,     3,    54,
       3,   -11,   -11,   -11,    76,   -11,    11,   -11,   -11,   -11,
     -10,    29,    88,    88,   -10,    82,    53,    99,    38,   -11,
     -11,    67,     3,   -11,    90
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,    26,    25,     8,    11,     0,     0,     0,     0,
       4,     0,     0,     5,     0,     0,    26,     0,    29,     1,
       0,     6,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    23,    10,    13,     0,    27,     0,    24,    30,     7,
      17,    18,    20,    21,    16,    14,    15,     0,    19,     9,
      28,     0,     0,    12,    22
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -11,   -11,   -11,    98,   -11,    -6,   -11,   -11
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     8,     9,    10,    15,    11,    36,    12
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int8 yytable[] =
{
      17,    27,    28,    29,    30,    31,    16,     3,    34,    -2,
       1,    13,     2,     3,    50,    14,    40,    41,    42,    43,
      44,    45,    46,     6,    48,     4,    18,     5,    19,     6,
      51,     7,    -3,    20,    22,     2,     3,    24,    25,    26,
      27,    28,    29,    30,    31,    35,    54,    33,     4,    38,
       5,    39,     6,    31,     7,    22,    23,    47,    24,    25,
      26,    27,    28,    29,    30,    31,    29,    30,    31,    22,
      23,    37,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    22,    23,    53,    24,    25,    26,    27,    28,    29,
      30,    31,    49,    22,    28,    29,    30,    31,    26,    27,
      28,    29,    30,    31,    30,    31,    52,    21
};

static const yytype_uint8 yycheck[] =
{
       6,    11,    12,    13,    14,    15,     3,     4,    14,     0,
       1,    16,     3,     4,     3,    17,    22,    23,    24,    25,
      26,    27,    28,    20,    30,    16,     3,    18,     0,    20,
      19,    22,     0,     1,     5,     3,     4,     8,     9,    10,
      11,    12,    13,    14,    15,     3,    52,    16,    16,     3,
      18,    16,    20,    15,    22,     5,     6,     3,     8,     9,
      10,    11,    12,    13,    14,    15,    13,    14,    15,     5,
       6,    21,     8,     9,    10,    11,    12,    13,    14,    15,
      16,     5,     6,    16,     8,     9,    10,    11,    12,    13,
      14,    15,    16,     5,    12,    13,    14,    15,    10,    11,
      12,    13,    14,    15,    14,    15,     7,     9
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,     3,     4,    16,    18,    20,    22,    24,    25,
      26,    28,    30,    16,    17,    27,     3,    28,     3,     0,
       1,    26,     5,     6,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    16,    28,     3,    29,    21,     3,    16,
      28,    28,    28,    28,    28,    28,    28,     3,    28,    16,
       3,    19,     7,    16,    28
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    23,    24,    24,    25,    25,    25,    25,    26,    26,
      26,    27,    26,    26,    28,    28,    28,    28,    28,    28,
      28,    28,    28,    28,    28,    28,    28,    29,    29,    30,
      30
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     1,     1,     2,     2,     3,     1,     4,
       2,     0,     5,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     5,     2,     3,     1,     1,     1,     2,     2,
       3
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 5:
#line 39 "ddcal.y" /* yacc.c:1648  */
    {
	    yyclearin;
	    if (graphics) {
		(void) fprintf(stdout,"error\n");
	    }
	}
#line 1276 "y.tab.c" /* yacc.c:1648  */
    break;

  case 7:
#line 46 "ddcal.y" /* yacc.c:1648  */
    {
	    yyclearin;
	    if (graphics) {
		(void) fprintf(stdout,"error\n");
	    }
	}
#line 1287 "y.tab.c" /* yacc.c:1648  */
    break;

  case 8:
#line 55 "ddcal.y" /* yacc.c:1648  */
    {
	    if (graphics) {
		(void) fprintf(stdout,"stop\n");
	    }
	}
#line 1297 "y.tab.c" /* yacc.c:1648  */
    break;

  case 9:
#line 60 "ddcal.y" /* yacc.c:1648  */
    {
	    if ((yyvsp[-3].symp)->value != NULL) {
		Cudd_RecursiveDeref(manager,(yyvsp[-3].symp)->value);
	    }
	    (yyvsp[-3].symp)->value = (yyvsp[-1].dval);
	    if (graphics) {
		(void) fprintf(stdout,"stop\n");
	    }
	}
#line 1311 "y.tab.c" /* yacc.c:1648  */
    break;

  case 10:
#line 69 "ddcal.y" /* yacc.c:1648  */
    {
	    noutputs = 1;
	    onames[0] = defname[0];
	    if (graphics) {
		DdNode *local = (yyvsp[-1].dval);
		if (!bddDump(manager,&local,NULL,0)) {
		    yyerror("bddDump failed!\n");
		    YYERROR;
		}
	    } else {
		if (!Cudd_PrintDebug(manager,(yyvsp[-1].dval),Cudd_ReadSize(manager),2)) {
		    yyerror("Cudd_PrintDebug failed!\n");
		    YYERROR;
		}
	    }
	    Cudd_RecursiveDeref(manager,lastexp);
	    lastexp = (yyvsp[-1].dval);
	}
#line 1334 "y.tab.c" /* yacc.c:1648  */
    break;

  case 11:
#line 87 "ddcal.y" /* yacc.c:1648  */
    {noutputs = 0; ddTypeSave = ddType; ddType = BDD_TYPE + ADD_TYPE;}
#line 1340 "y.tab.c" /* yacc.c:1648  */
    break;

  case 12:
#line 87 "ddcal.y" /* yacc.c:1648  */
    {
	    ddType = ddTypeSave;
	    if (graphics) {
		if (!bddDump(manager,nodes,NULL,0)) {
		    yyerror("bddDump failed!\n");
		    YYERROR;
		}
	    }
	}
#line 1354 "y.tab.c" /* yacc.c:1648  */
    break;

  case 14:
#line 100 "ddcal.y" /* yacc.c:1648  */
    {
	    if (isBDD(ddType))
		(yyval.dval) = Cudd_bddOr(manager,(yyvsp[-2].dval),(yyvsp[0].dval));
	    else
		(yyval.dval) = Cudd_addApply(manager,Cudd_addOr,(yyvsp[-2].dval),(yyvsp[0].dval));
	    Cudd_Ref((yyval.dval));
	    Cudd_RecursiveDeref(manager,(yyvsp[-2].dval));
	    Cudd_RecursiveDeref(manager,(yyvsp[0].dval));
	}
#line 1368 "y.tab.c" /* yacc.c:1648  */
    break;

  case 15:
#line 109 "ddcal.y" /* yacc.c:1648  */
    {
	    if (isBDD(ddType))
		(yyval.dval) = Cudd_bddAnd(manager,(yyvsp[-2].dval),(yyvsp[0].dval));
	    else
		(yyval.dval) = Cudd_addApply(manager,Cudd_addTimes,(yyvsp[-2].dval),(yyvsp[0].dval));
	    Cudd_Ref((yyval.dval));
	    Cudd_RecursiveDeref(manager,(yyvsp[-2].dval));
	    Cudd_RecursiveDeref(manager,(yyvsp[0].dval));
	}
#line 1382 "y.tab.c" /* yacc.c:1648  */
    break;

  case 16:
#line 118 "ddcal.y" /* yacc.c:1648  */
    {
	    if (isBDD(ddType))
		(yyval.dval) = Cudd_bddXor(manager,(yyvsp[-2].dval),(yyvsp[0].dval));
	    else
		(yyval.dval) = Cudd_addApply(manager,Cudd_addXor,(yyvsp[-2].dval),(yyvsp[0].dval));
	    Cudd_Ref((yyval.dval));
	    Cudd_RecursiveDeref(manager,(yyvsp[-2].dval));
	    Cudd_RecursiveDeref(manager,(yyvsp[0].dval));
	}
#line 1396 "y.tab.c" /* yacc.c:1648  */
    break;

  case 17:
#line 127 "ddcal.y" /* yacc.c:1648  */
    {
	    if (isBDD(ddType))
		(yyval.dval) = Cudd_bddXnor(manager,(yyvsp[-2].dval),(yyvsp[0].dval));
	    else
		(yyval.dval) = Cudd_addApply(manager,Cudd_addXnor,(yyvsp[-2].dval),(yyvsp[0].dval));
	    Cudd_Ref((yyval.dval));
	    Cudd_RecursiveDeref(manager,(yyvsp[-2].dval));
	    Cudd_RecursiveDeref(manager,(yyvsp[0].dval));
	}
#line 1410 "y.tab.c" /* yacc.c:1648  */
    break;

  case 18:
#line 136 "ddcal.y" /* yacc.c:1648  */
    {
	    if (isBDD(ddType))
		(yyval.dval) = Cudd_bddOr(manager,Cudd_Not((yyvsp[-2].dval)),(yyvsp[0].dval));
	    else
		(yyval.dval) = Cudd_addIte(manager,(yyvsp[-2].dval),(yyvsp[0].dval),Cudd_ReadOne(manager));
	    Cudd_Ref((yyval.dval));
	    Cudd_RecursiveDeref(manager,(yyvsp[-2].dval));
	    Cudd_RecursiveDeref(manager,(yyvsp[0].dval));
	}
#line 1424 "y.tab.c" /* yacc.c:1648  */
    break;

  case 19:
#line 145 "ddcal.y" /* yacc.c:1648  */
    {
	    if (isBDD(ddType))
		(yyval.dval) = Cudd_bddConstrain(manager,(yyvsp[-2].dval),(yyvsp[0].dval));
	    else
		(yyval.dval) = Cudd_addConstrain(manager,(yyvsp[-2].dval),(yyvsp[0].dval));
	    Cudd_Ref((yyval.dval));
	    Cudd_RecursiveDeref(manager,(yyvsp[-2].dval));
	    Cudd_RecursiveDeref(manager,(yyvsp[0].dval));
	}
#line 1438 "y.tab.c" /* yacc.c:1648  */
    break;

  case 20:
#line 154 "ddcal.y" /* yacc.c:1648  */
    {
	    if (isBDD(ddType))
		(yyval.dval) = Cudd_bddExistAbstract(manager,(yyvsp[-2].dval),(yyvsp[0].dval));
	    else
		(yyval.dval) = Cudd_addOrAbstract(manager,(yyvsp[-2].dval),(yyvsp[0].dval));
	    if ((yyval.dval) == NULL) {
		Cudd_RecursiveDeref(manager,(yyvsp[-2].dval));
		Cudd_RecursiveDeref(manager,(yyvsp[0].dval));
		YYERROR;
	    }
	    Cudd_Ref((yyval.dval));
	    Cudd_RecursiveDeref(manager,(yyvsp[-2].dval));
	    Cudd_RecursiveDeref(manager,(yyvsp[0].dval));
	}
#line 1457 "y.tab.c" /* yacc.c:1648  */
    break;

  case 21:
#line 168 "ddcal.y" /* yacc.c:1648  */
    {
	    if (isBDD(ddType))
		(yyval.dval) = Cudd_bddUnivAbstract(manager,(yyvsp[-2].dval),(yyvsp[0].dval));
	    else
		(yyval.dval) = Cudd_addUnivAbstract(manager,(yyvsp[-2].dval),(yyvsp[0].dval));
	    if ((yyval.dval) == NULL) {
		Cudd_RecursiveDeref(manager,(yyvsp[-2].dval));
		Cudd_RecursiveDeref(manager,(yyvsp[0].dval));
		YYERROR;
	    }
	    Cudd_Ref((yyval.dval));
	    Cudd_RecursiveDeref(manager,(yyvsp[-2].dval));
	    Cudd_RecursiveDeref(manager,(yyvsp[0].dval));
	}
#line 1476 "y.tab.c" /* yacc.c:1648  */
    break;

  case 22:
#line 182 "ddcal.y" /* yacc.c:1648  */
    {
	    if (!isBDD(ddType)) {
		DdNode *var = Cudd_addIthVar(manager,(yyvsp[-2].symp)->value->index);
		Cudd_Ref(var);
		if (Cudd_IsConstant((yyvsp[-2].symp)->value) || (yyvsp[-2].symp)->value != var) {
		    Cudd_RecursiveDeref(manager,(yyvsp[-4].dval));
		    Cudd_RecursiveDeref(manager,(yyvsp[0].dval));
		    Cudd_RecursiveDeref(manager,var);
		    yyerror("invalid variable name");
		    YYERROR;
		}
		Cudd_RecursiveDeref(manager,var);
		(yyval.dval) = Cudd_addCompose(manager,(yyvsp[-4].dval),(yyvsp[0].dval),(yyvsp[-2].symp)->value->index);
	    } else {
		if (Cudd_IsConstant((yyvsp[-2].symp)->value) ||
		    (yyvsp[-2].symp)->value != Cudd_bddIthVar(manager,(yyvsp[-2].symp)->value->index)) {
		    Cudd_RecursiveDeref(manager,(yyvsp[-4].dval));
		    Cudd_RecursiveDeref(manager,(yyvsp[0].dval));
		    yyerror("invalid variable name");
		    YYERROR;
		}
		(yyval.dval) = Cudd_bddCompose(manager,(yyvsp[-4].dval),(yyvsp[0].dval),(yyvsp[-2].symp)->value->index);
	    }
	    if ((yyval.dval) == NULL) {
		Cudd_RecursiveDeref(manager,(yyvsp[-4].dval));
		Cudd_RecursiveDeref(manager,(yyvsp[0].dval));
		YYERROR;
	    }
	    Cudd_Ref((yyval.dval));
	    Cudd_RecursiveDeref(manager,(yyvsp[-4].dval));
	    Cudd_RecursiveDeref(manager,(yyvsp[0].dval));
	}
#line 1513 "y.tab.c" /* yacc.c:1648  */
    break;

  case 23:
#line 214 "ddcal.y" /* yacc.c:1648  */
    {
	    if (isBDD(ddType))
		(yyval.dval) = Cudd_Not((yyvsp[-1].dval));
	    else {
		(yyval.dval) = Cudd_addCmpl(manager,(yyvsp[-1].dval));
		Cudd_Ref((yyval.dval));
		Cudd_RecursiveDeref(manager,(yyvsp[-1].dval));
	    }
	}
#line 1527 "y.tab.c" /* yacc.c:1648  */
    break;

  case 24:
#line 223 "ddcal.y" /* yacc.c:1648  */
    {
	    (yyval.dval) = (yyvsp[-1].dval);
	}
#line 1535 "y.tab.c" /* yacc.c:1648  */
    break;

  case 25:
#line 226 "ddcal.y" /* yacc.c:1648  */
    {
	    (yyval.dval) = (yyvsp[0].dval);
	    Cudd_Ref((yyval.dval));
	}
#line 1544 "y.tab.c" /* yacc.c:1648  */
    break;

  case 26:
#line 230 "ddcal.y" /* yacc.c:1648  */
    {
	    if ((yyvsp[0].symp)->value == NULL) {
		struct symtab_t *auxp;
		if (isBDD(ddType))
		    if ((auxp = exists((yyvsp[0].symp)->name,ADD_TYPE)) != NULL) {
			(yyvsp[0].symp)->value = Cudd_bddIthVar(manager,auxp->value->index);
		    } else {
			(yyvsp[0].symp)->value = Cudd_bddNewVar(manager);
		    }
		else
		    if ((auxp = exists((yyvsp[0].symp)->name,BDD_TYPE)) != NULL) {
			(yyvsp[0].symp)->value = Cudd_addIthVar(manager,auxp->value->index);
		    } else {
			(yyvsp[0].symp)->value = Cudd_addNewVar(manager);
		    }
		Cudd_Ref((yyvsp[0].symp)->value);
	    }
	    (yyval.dval) = (yyvsp[0].symp)->value;
	    Cudd_Ref((yyval.dval));
	}
#line 1569 "y.tab.c" /* yacc.c:1648  */
    break;

  case 27:
#line 252 "ddcal.y" /* yacc.c:1648  */
    {
	    if ((yyvsp[0].symp)->value == NULL) {
		YYERROR;
	    }
	    nodes[noutputs] = (yyvsp[0].symp)->value;
	    onames[noutputs] = (yyvsp[0].symp)->name;
	    noutputs++;
	}
#line 1582 "y.tab.c" /* yacc.c:1648  */
    break;

  case 28:
#line 260 "ddcal.y" /* yacc.c:1648  */
    {
	    if ((yyvsp[0].symp)->value == NULL) {
		YYERROR;
	    }
	    nodes[noutputs] = (yyvsp[0].symp)->value;
	    onames[noutputs] = (yyvsp[0].symp)->name;
	    noutputs++;
	}
#line 1595 "y.tab.c" /* yacc.c:1648  */
    break;

  case 29:
#line 270 "ddcal.y" /* yacc.c:1648  */
    {
	    if (strcmp((yyvsp[0].symp)->name, "reorder") == 0) {
		int option = (Cudd_ReadSize(manager) < 10) ?
		    CUDD_REORDER_EXACT : CUDD_REORDER_SIFT_CONVERGE;
		if (!Cudd_ReduceHeap(manager,option,1)) {
		    yyerror("Cudd_ReduceHeap failed!");
		    YYERROR;
		}
		if (graphics) {
		    (void) fprintf(stdout,"stop\n");
		}
	    } else if (strcmp((yyvsp[0].symp)->name, "last") == 0) {
		if (!do_last(NULL,0)) YYERROR;
	    } else if (strcmp((yyvsp[0].symp)->name, "concentrate") == 0) {
		concentrate = 1;
		if (graphics) {
		    (void) fprintf(stdout,"stop\n");
		}
	    } else if (strcmp((yyvsp[0].symp)->name, "noconcentrate") == 0) {
		concentrate = 0;
		if (graphics) {
		    (void) fprintf(stdout,"stop\n");
		}
	    } else if (strcmp((yyvsp[0].symp)->name, "complementarcs") == 0) {
		ddType = BDD_TYPE;
		if (graphics) {
		    (void) fprintf(stdout,"stop\n");
		}
	    } else if (strcmp((yyvsp[0].symp)->name, "nocomplementarcs") == 0) {
		ddType = ADD_TYPE;
		if (graphics) {
		    (void) fprintf(stdout,"stop\n");
		}
	    } else {
		yyerror("unrecognized command");
		YYERROR;
	    }
	}
#line 1638 "y.tab.c" /* yacc.c:1648  */
    break;

  case 30:
#line 308 "ddcal.y" /* yacc.c:1648  */
    {
	    if (strcmp((yyvsp[-1].symp)->name, "down") == 0) {
		int i,x,y,level,retval;
		int *permutation;
		x = (yyvsp[0].symp)->value->index;
		if (isBDD(ddType)) {
		    if (Cudd_IsConstant((yyvsp[0].symp)->value) ||
			(yyvsp[0].symp)->value != Cudd_bddIthVar(manager,x)) {
			yyerror("invalid variable name");
			YYERROR;
		    }
		} else {
		    DdNode *var = Cudd_addIthVar(manager,x);
		    Cudd_Ref(var);
		    if (Cudd_IsConstant((yyvsp[0].symp)->value) || (yyvsp[0].symp)->value != var) {
			yyerror("invalid variable name");
			Cudd_RecursiveDeref(manager,var);
			YYERROR;
		    }
		    Cudd_RecursiveDeref(manager,var);
		}
		level = Cudd_ReadIndex(manager,x);
		if (level < Cudd_ReadSize(manager) - 1) {
		    y = Cudd_ReadInvPerm(manager,level+1);
		    permutation = ALLOC(int,Cudd_ReadSize(manager));
		    for (i = 0; i < Cudd_ReadSize(manager); i++) {
			permutation[i] = Cudd_ReadInvPerm(manager,i);
		    }
		    permutation[level] = y;
		    permutation[level+1] = x;
		    retval = Cudd_ShuffleHeap(manager,permutation);
		    FREE(permutation);
		    if (!retval) {
			yyerror("Cudd_ShuffleHeap failed!");
			YYERROR;
		    }
		    if (!do_last(NULL,0)) YYERROR;
		} else if (graphics) {
		    (void) fprintf(stdout,"beep\n");
		}
	    } else if (strcmp((yyvsp[-1].symp)->name, "up") == 0) {
		int i,x,y,level,retval;
		int *permutation;
		y = (yyvsp[0].symp)->value->index;
		if (isBDD(ddType)) {
		    if (Cudd_IsConstant((yyvsp[0].symp)->value) ||
			(yyvsp[0].symp)->value != Cudd_bddIthVar(manager,y)) {
			yyerror("invalid variable name");
			YYERROR;
		    }
		} else {
		    DdNode *var = Cudd_addIthVar(manager,y);
		    Cudd_Ref(var);
		    if (Cudd_IsConstant((yyvsp[0].symp)->value) || (yyvsp[0].symp)->value != var) {
			yyerror("invalid variable name");
			Cudd_RecursiveDeref(manager,var);
			YYERROR;
		    }
		    Cudd_RecursiveDeref(manager,var);
		}
		level = Cudd_ReadIndex(manager,y);
		if (level > 0) {
		    x = Cudd_ReadInvPerm(manager,level-1);
		    permutation = ALLOC(int,Cudd_ReadSize(manager));
		    for (i = 0; i < Cudd_ReadSize(manager); i++) {
			permutation[i] = Cudd_ReadInvPerm(manager,i);
		    }
		    permutation[level] = x;
		    permutation[level-1] = y;
		    retval = Cudd_ShuffleHeap(manager,permutation);
		    FREE(permutation);
		    if (!retval) {
			yyerror("Cudd_ShuffleHeap failed!");
			YYERROR;
		    }
		    if (!do_last(NULL,0)) YYERROR;
		} else if (graphics) {
		    (void) fprintf(stdout,"beep\n");
		}
	    } else if (strcmp((yyvsp[-1].symp)->name, "dot") == 0) {
		if (!do_last((yyvsp[0].symp)->name,0)) YYERROR;
		if (graphics) {
		    (void) fprintf(stdout,"stop\n");
		}
	    } else if (strcmp((yyvsp[-1].symp)->name, "blif") == 0) {
		if (!do_last((yyvsp[0].symp)->name,1)) YYERROR;
		if (graphics) {
		    (void) fprintf(stdout,"stop\n");
		}
	    } else {
		yyerror("unrecognized command");
		YYERROR;
	    }
	}
#line 1737 "y.tab.c" /* yacc.c:1648  */
    break;


#line 1741 "y.tab.c" /* yacc.c:1648  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 403 "ddcal.y" /* yacc.c:1907  */



/* look up a symbol table entry, add if not present */
struct symtab_t *
symlook(char const *s, int type)
{
    struct symtab_t *sp;
    
    for (sp = symtab; sp < &symtab[NSYMS]; sp++) {
	/* is it already here? */
	if (sp->name && !strcmp(sp->name, s) && (sp->type & type))
	    return sp;
	
	/* is it free? */
	if (!sp->name) {
	    sp->name = strdup(s);
	    sp->type = type;
	    sp->value = NULL;
	    return sp;
	}
	/* otherwise continue to next */
    }
    yyerror("Too many symbols");
    exit(1);	/* cannot continue */

} /* end of symlook */

struct symtab_t *
exists(char const *s, int type)
{
    struct symtab_t *sp;
    
    for (sp = symtab; sp < &symtab[NSYMS]; sp++) {
	/* is it already here? */
	if (!sp->name)
	    return NULL;
	if (!strcmp(sp->name, s) && sp->type == type)
	    return sp;
    }
    return NULL;

} /* end of exists */

/**Function********************************************************************

  Synopsis    [Main program for the BDD calculator.]

  Description []

  SideEffects [None]

  SeeAlso     []

******************************************************************************/
int
main(int argc, char **argv)
{
    int c;	/* variable to read in options */

    setbuf(stdin,NULL);
    setbuf(stdout,NULL);
    manager = Cudd_Init(0,0,CUDD_UNIQUE_SLOTS,1024,1048576);
    graphics = 0;
    concentrate = 0;
    ddType = BDD_TYPE;
    lastexp = Cudd_Not(Cudd_ReadOne(manager));
    Cudd_Ref(lastexp);
    noutputs = 0;

    while ((c = getopt(argc, argv, "gh")) != EOF) {
	switch(c) {
	case 'g':
	    graphics = 1;
	    break;
	case 'h':
	default:
	    usage(argv[0]);
	    break;
	}
    }

    yyparse();

    exit(0);

} /* end of main */


/**Function********************************************************************

  Synopsis	[Error reporting routine.]

  Description	[Error reporting routine.]

  SideEffects	[None]

  SeeAlso	[]

******************************************************************************/
int
yyerror(char const *msg)
{
    if (!graphics) {
	(void) fprintf(stderr, "%s\n", msg);
    }
    return(1);

} /* end of yyerror */


/**Function********************************************************************

  Synopsis    [Writes BDDs to a file in dot format.]

  Description [Writes BDDs to a file in dot format. If parameter filename
  is non-NULL, the output is in not laid out; is in standard format; and
  goes to filename. If filename is NULL, the output is piped through dot
  and sent to stdout.  Returns 1 in case of success; 0 otherwise.]

  SideEffects [None]

  SeeAlso     []

******************************************************************************/
int
bddDump(
  DdManager *dd		/* DD manager */,
  DdNode **dnodes	/* nodes whose BDDs should be dumped */,
  char *filename	/* name of file for dot format output */,
  int dumpBlif		/* format for file dump (1:blif, 0:dot) */
)
{
    FILE *toCommand;		/* file descriptor for pipe */
    FILE *fromCommand;		/* file descriptor for pipe */
    FILE *fp;			/* file descriptor for file output */
    char s[512];		/* buffer for communications through pipe */
    char *args[4];		/* arguments for call to dot */
    char const **inames = NULL;	/* array of input names */
    int retval = 0;		/* 0 -> failure; 1 -> success */
    struct symtab_t *sp;
    int index;
    int pid;

    /* Find the input names. */
    inames = ALLOC(char const *,Cudd_ReadSize(dd));
    if (inames == NULL) {
	(void) fprintf(stderr,"Panic: malloc returned NULL!\n");
	exit(2);
    }
    /* Initialize to NULL all entries of inames, so that we can tell
    ** whether we find synonims for variables. The first we find in the
    ** table is the original name. The others are ignored.
    */
    for (index = 0; index < Cudd_ReadSize(dd); index++) {
	inames[index] = NULL;
    }
    for (sp = symtab; sp < &symtab[NSYMS]; sp++) {
	if (!sp->name) break;
	if (sp->value == NULL) continue;
	if (Cudd_IsComplement(sp->value)) continue;
	if (Cudd_IsConstant(sp->value)) continue;
	index = Cudd_NodeReadIndex(sp->value);
	if (isBDD(sp->type)) {
	    if ((inames[index] == NULL) &&
		(sp->value == Cudd_bddIthVar(dd,index))) {
		inames[index] = sp->name;
	    }
	} else {
	    DdNode *var = Cudd_addIthVar(dd,index);
	    Cudd_Ref(var);
	    if (inames[index] == NULL && sp->value == var) {
		inames[index] = sp->name;
	    }
	    Cudd_RecursiveDeref(dd,var);
	}
    }

    if (filename != NULL) {
	fp = fopen(filename,"w");
	if (fp == NULL) return(0);
	if (dumpBlif) {
	    retval = Cudd_DumpBlif(dd,noutputs,dnodes,inames,onames,
				   filename,fp,0);
	} else {
	    retval = Cudd_DumpDot(dd,noutputs,dnodes,inames,onames,fp);
	}
	fclose(fp);
	return(retval);
    }

    /* Set up args to call "dot -Tplain." */
    args[0] = util_strsav("dot");
    args[1] = util_strsav("-Tplain");
    if (concentrate) {
	args[2] = util_strsav("-Gconcentrate=true");
    } else {
	args[2] = 0;
    }
    args[3] = 0;

    /* Set up bidirectional pipe to/from dot. */
    /* A unidirectional pipe should suffice. We'll try it some day. */
    retval = util_pipefork(args,&toCommand,&fromCommand,&pid);
    if (retval == 0) {
	(void) fprintf(stderr,"Panic: util_pipefork returned 0!\n");
	exit(2);
    }

    retval = Cudd_DumpDot(dd,noutputs,dnodes,inames,onames,toCommand);
    if (retval == 0) {
	(void) fprintf(stderr,"Panic: Cudd_DumpDot returned 0!\n");
	exit(2);
    }
    fclose(toCommand);
    FREE(inames);

    while (!feof(fromCommand)) {
	if (fgets(s,100,fromCommand))
	    (void) fprintf(stdout,"%s",s);
    }

    return(1);

} /* end of bddDump */


/**Function********************************************************************

  Synopsis    [Prints usage info.]

  Description [Prints usage info and exits.]

  SideEffects [None]

  SeeAlso     []

******************************************************************************/
static void
usage(char const *prog)
{
    (void) fprintf(stderr, "usage: %s [options]\n", prog);
    (void) fprintf(stderr, "   -g\t\tproduce BDD layout\n");
    (void) fprintf(stderr, "   -h\t\tprints this message\n");
    exit(2);

} /* end of usage */


/**Function********************************************************************

  Synopsis    [Prints the last expression.]

  Description [Prints the last expression.]

  SideEffects [None]

  SeeAlso     []

******************************************************************************/
int
do_last(char *filename, int dumpBlif)
{
    if (noutputs == 0) {
	if (graphics) {
	    (void) fprintf(stdout,"stop\n");
	}
	return(1);
    }
    if (graphics || filename != NULL) {
	if (onames[0] == defname[0]) {
	    if (!bddDump(manager,&lastexp,filename,dumpBlif)) {
		yyerror("bddDump failed!\n");
		return(0);
	    }
	} else {
	    if (!bddDump(manager,nodes,filename,dumpBlif)) {
		yyerror("bddDump failed!\n");
		return(0);
	    }
	}
    } else {
	if (!Cudd_PrintDebug(manager,lastexp,Cudd_ReadSize(manager),2)) {
	    yyerror("Cudd_PrintDebug failed!\n");
	    return(0);
	}
    }
    return(1);

} /* end of do_last */
